//
//            ̼(BSC)Ա
//            Baby Fox Simple Class
//
//    ̱ȨʹȨг򰮺
//
//                class FIni
//

#ifndef _FIni_Appeared_
#define _FIni_Appeared_

#include <stdio.h>
#include <stdlib.h>
#include "FString.h"
#include "FArray.h"

class FIni
{
    class FIniNode
    {
    public:
        FString name;
        FString value;

    public:
        FIniNode &operator =(FIniNode &other){name=other.name;value=other.value;return *this;}

        bool operator >(FIniNode other){return name>other.name;}
        bool operator <(FIniNode other){return name<other.name;}
    };

    class FIniSection
    {
    public:
        FString name;
        FArray <FIniNode> keys;

    public:
        FIniSection &operator =(FIniSection &other){name=other.name;keys=other.keys;return *this;}

    public:
        bool operator >(FIniSection other){return name>other.name;}
        bool operator <(FIniSection other){return name<other.name;}

        FIniNode operator[](unsigned int index){return keys[index];}

        //ȡֵ
        unsigned int GetCount(void){return keys.GetCount();}
    };

//˽ݺ˽к
protected:
    FString filename;
    FArray <FIniSection> data;
    bool Changed;

    //ֶ
    bool AddSection(char *name);
    //Ӽֵ
    bool AddKey(char *section, char *name, char *value=NULL);
    //Ӽֵ
    bool AddKey(char *section, char *name, int value=0);
    //Ƚַ
    bool notEqual(char *str1, char *str2, bool MatchCase);

//
public:
    //СдǷȼ
    bool MatchCase;

public:
//ϵͳú벻Ҫע

    FIni(char *filename=NULL, bool CaseMatch=false);
    virtual ~FIni(void);

//
    FIniSection operator [](unsigned int index){return data[index];}

//ûӿڷ

    //ҽIniļ
    bool Attach(char *Filename, bool CaseMatch=false);
    //ȡ
    unsigned int GetCount(void){return data.GetCount();}
    //
    bool UpdateData(bool isLoading=true);
    //üֵ
    bool SetValue(char *section, char *key, char *value);
    //üֵ
    bool SetValue(char *section, char *key, int value);
    //ȡֵ
    bool GetValue(char *section, char *key, FString &value);
    //ȡֵ
    bool GetValue(char *section, char *key, int &value);
    //ɾֵ
    bool DeleteKey(char *section, char *name);
    //ɾֶ
    bool DeleteSection(char *name);
};

//¸ǽӿڵľʵ֣ûбҪ˽ǵ
//ֻҪгĽӿڲʹǾ
//ĻǾ

//˽к

bool FIni::AddSection(char *name)
{
    FIniSection newSection;
    newSection.name=name;
    data.Add(newSection);
    return true;
}

bool FIni::AddKey(char *section, char *name, char *value)
{
    FIniNode newNode;
    newNode.name=name;
    newNode.value=value;

    for(unsigned int i=0; i<data.GetCount()&&notEqual(data[i].name, section, MatchCase); i++);

    if(i==data.GetCount())
    {
        AddSection(section);
        AddKey(section, name, value);
    }
    else
        data[i].keys.Add(newNode);

    return true;
}

bool FIni::AddKey(char *section, char *name, int value)
{
    FString buffer;
    buffer.buffer();
    sprintf(buffer, "%i", value);
    return AddKey(section, name, buffer);
}

bool FIni::notEqual(char *str1, char *str2, bool MatchCase)
{
    FString temp1=str1;
    FString temp2=str2;

    if(!MatchCase)
    {
        strlwr(temp1);
        strlwr(temp2);
    }

    return temp1!=temp2;
}

//ϵͳú벻Ҫע

FIni::FIni(char *Filename, bool CaseMatch)
{
    if(Filename==NULL)
        return;
    Attach(Filename, CaseMatch);
}

FIni::~FIni()
{
    UpdateData(false);
}

//ûӿڷ

bool FIni::Attach(char *Filename, bool CaseMatch)
{
    filename=Filename;
    MatchCase=CaseMatch;
    return UpdateData(true);
}

bool FIni::UpdateData(bool isLoading)
{
    if(filename=="")return false;

    FILE *ini;

    if(isLoading)
    {
        FString buffer;
        FString Section;

        if((ini=fopen(filename, "r"))==NULL)
            return false;

        buffer.buffer(1024);

        while(fgets(buffer, 1024, ini))
        {
            if(right(buffer, 1)=="\n")
                buffer[buffer.GetLength()-1]='\0';

            buffer=trim(buffer);
            if(buffer=="")
            {
                buffer.buffer(1024);
                continue;
            }

            if(buffer[0]=='[')
            {
                buffer=right(buffer, buffer.GetLength()-1);
                if(buffer[buffer.GetLength()-1]==']')
                    buffer[buffer.GetLength()-1]='\0';

                Section=buffer;
            }
            else
            {
                FString Key, Value;
                for(unsigned int i=0; i<buffer.GetLength()&&buffer[i]!='='; i++)
                    Key+=buffer[i];

                if(buffer[i]=='=')
                {
                    for(unsigned int j=i+1; j<buffer.GetLength(); j++)
                        Value+=buffer[j];
                }

                AddKey(Section, Key, Value);
            }

            buffer.buffer(1024);
        }
    }
    else
    {
        if(!Changed)return true;
        if((ini=fopen(filename, "w"))==NULL)
            return false;

        for(unsigned int i=0; i<data.GetCount(); i++)
        {
            if(data[i].name!="")
                fprintf(ini, "[%s]\n", data[i].name);

            for(unsigned int j=0; j<data[i].keys.GetCount(); j++)
            {
                fprintf(ini, "%s=", data[i].keys[j].name);

                if(data[i].keys[j].value!="")
                    fprintf(ini, "%s\n", data[i].keys[j].value);
                else
                    fprintf(ini, "\n");
            }

            if(i<data.GetCount()-1)fprintf(ini, "\n");
        }
    }

    fclose(ini);
    Changed=false;
    return false;
}

bool FIni::SetValue(char *section, char *key, char *value)
{
    for(unsigned int i=0; i<data.GetCount()&&notEqual(data[i].name, section, MatchCase); i++);

    if(i==data.GetCount())
    {
        AddKey(section, key, value);
        Changed=true;
        return true;
    }

    for(unsigned int j=0; j<data[i].keys.GetCount()&&notEqual(data[i].keys[j].name, key, MatchCase); j++);

    if(j==data[i].keys.GetCount())
        AddKey(section, key, value);
    else
        data[i].keys[j].value=value;

    Changed=true;
    return true;
}

bool FIni::SetValue(char *section, char *key, int value)
{
    FString buffer;
    buffer.buffer();
    sprintf(buffer.GetData(), "%i", value);
    bool result=SetValue(section, key, buffer);
    return result;
}

bool FIni::GetValue(char *section, char *key, FString &value)
{
    for(unsigned int i=0; i<data.GetCount()&&notEqual(data[i].name, section, MatchCase); i++);

    if(i==data.GetCount())return false;

    for(unsigned int j=0; j<data[i].keys.GetCount()&&notEqual(data[i].keys[j].name, key, MatchCase); j++);

    if(j==data[i].keys.GetCount())return false;

    value=data[i].keys[j].value;
    return true;
}

bool FIni::GetValue(char *section, char *key, int &value)
{
    FString buffer;
    bool result=GetValue(section, key, buffer);

    if(buffer.GetLength())
        value=atoi(buffer);
    else
        value=0;

    return result;
}

bool FIni::DeleteKey(char *section, char *name)
{
    for(unsigned int i=0; i<data.GetCount()&&notEqual(data[i].name, section, MatchCase); i++);

    if(i==data.GetCount())return false;

    for(unsigned int j=0; j<data[i].keys.GetCount()&&notEqual(data[i].keys[j].name, name, MatchCase); j++);

    if(j==data[i].keys.GetCount())return false;

    data[i].keys.Delete(j);
    Changed=true;
    return true;
}

bool FIni::DeleteSection(char *name)
{
    for(unsigned int i=0; i<data.GetCount()&&notEqual(data[i].name, name, MatchCase); i++);

    if(i==data.GetCount())
        return false;

    data.Delete(i);
    Changed=true;
    return true;
}

#endif
